<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class Db
    {
    var $no_error = 0;
    var $connection;
    var $query_id = 0;

    function Db($db_host, $db_user, $db_password = "", $db_name = "", $db_pconnect = 0)
        {
        $connect_handle=($db_pconnect) ? "mysql_pconnect" : "mysql_connect";

        if (!$this->connection=$connect_handle($db_host, $db_user, $db_password))
            {
            $this->error("Could not connect to the database server ($db_host, $db_user).", 1);
            }

        if ($db_name != "")
            {
            if (!@mysql_select_db($db_name))
                {
                @mysql_close($this->connection);
                $this->error("Could not select database ($db_name).", 1);
                }
            }
        //return $this->connection;
        }

    function close()
        {
        if ($this->connection)
            {
            if ($this->query_id)
                {
                @mysql_free_result($this->query_id);
                }

            return@mysql_close($this->connection);
            }
        else
            {
            return false;
            }
        }

    function query($query = "")
        {
        global $lang;
        mysql_query("set names '" . $lang['encoding'] . "'", $this->connection);

        unset($this->query_id);

        if ($query != "")
            {
            if (!$this->query_id=@mysql_query($query, $this->connection))
                {
                $this->error("<b>Bad SQL Query</b>: " . htmlentities($query) . "<br /><b>" . mysql_error() . "</b>");
                }

            return $this->query_id;
            }
        }

    //return array() if 0 rows returned
    function fetch_all($query_id = -1, $assoc = 0)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        if ($this->query_id)
            {
            while ($row=(($assoc) ? mysql_fetch_assoc($this->query_id) : mysql_fetch_array($this->query_id)))
                {
                $data[]=$row;
                }
            }

        return $data ? $data : array();
        }

    //return array() if 0 rows returned
    function fetch_array($query_id = -1, $assoc = 0)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        if ($this->query_id)
            {
            $data=($assoc) ? mysql_fetch_assoc($this->query_id) : mysql_fetch_array($this->query_id);
            }

        return $data ? $data : array();
        }

    function free_result($query_id = -1)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        return@mysql_free_result($this->query_id);
        }

    function get_numrows($query_id = -1)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        return mysql_num_rows($this->query_id);
        }

    function get_insert_id() { return ($this->connection) ? @mysql_insert_id($this->connection) : 0; }

    function get_numfields($query_id = -1)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        return@mysql_num_fields($this->query_id);
        }

    function get_fieldname($query_id = -1, $offset)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        return@mysql_field_name($this->query_id, $offset);
        }

    function get_fieldtype($query_id = -1, $offset)
        {
        if ($query_id != -1)
            {
            $this->query_id=$query_id;
            }

        return@mysql_field_type($this->query_id, $offset);
        }

    function affected_rows() { return ($this->connection) ? @mysql_affected_rows($this->connection) : 0; }

    function is_empty($query = "")
        {
        if ($query != "")
            {
            $this->query($query);
            }

        return (!mysql_num_rows($this->query_id)) ? 1 : 0;
        }

    function not_empty($query = "")
        {
        if ($query != "")
            {
            $this->query($query);
            }

        return (!mysql_num_rows($this->query_id)) ? 0 : 1;
        }

    function error($errmsg, $halt = 0)
        {
        if (!$this->no_error)
            {
            echo "<br /><font color='#FF0000'><b>An unexpected error occured. Please try again later.</b></font><br />";

            if ($halt)
                {
                exit;
                }
            }
        }
    } // end of class
?>